package com.sun.org.apache.xalan.internal.xsltc.runtime;

import org.xml.sax.SAXException;
import com.sun.org.apache.xml.internal.serializer.EmptySerializer;

public final class StringValueHandler extends EmptySerializer
{
    private StringBuilder _buffer;
    private String _str;
    private static final String EMPTY_STR = "";
    private boolean m_escaping;
    private int _nestedLevel;
    
    public StringValueHandler() {
        this._buffer = new StringBuilder();
        this._str = null;
        this.m_escaping = false;
        this._nestedLevel = 0;
    }
    
    @Override
    public void characters(char[] ch, int off, int len) throws SAXException {
        if (this._nestedLevel > 0) {
            return;
        }
        if (this._str != null) {
            this._buffer.append(this._str);
            this._str = null;
        }
        this._buffer.append(ch, off, len);
        return;
    }
    
    public String getValue() {
        if (this._buffer.length() != 0) {
            String result = this._buffer.toString();
            this._buffer.setLength(0);
            return result;
        }
        String result = this._str;
        this._str = null;
        return (result != null) ? result : "";
    }
    
    @Override
    public void characters(String characters) throws SAXException {
        if (this._nestedLevel > 0) {
            return;
        }
        if (this._str == null && this._buffer.length() == 0) {
            this._str = characters;
        }
        else {
            if (this._str != null) {
                this._buffer.append(this._str);
                this._str = null;
            }
            this._buffer.append(characters);
        }
        return;
    }
    
    @Override
    public void startElement(String qname) throws SAXException {
        ++this._nestedLevel;
    }
    
    @Override
    public void endElement(String qname) throws SAXException {
        --this._nestedLevel;
    }
    
    @Override
    public boolean setEscaping(boolean bool) {
        boolean oldEscaping = this.m_escaping;
        return this.m_escaping = bool;
    }
    
    public String getValueOfPI() {
        String value = this.getValue();
        if (value.indexOf("?>") > 0) {
            int n = value.length();
            StringBuilder valueOfPI = new StringBuilder();
            int i = 0;
            while (i < n) {
                char ch = value.charAt(i++);
                if (ch == '?' && value.charAt(i) == '>') {
                    valueOfPI.append("? >");
                    ++i;
                }
                else {
                    valueOfPI.append(ch);
                }
            }
            return valueOfPI.toString();
        }
        return value;
    }
}
